Click here to Skip to main content
Click here to Skip to main content

Modular InnoSetup Dependency Installer

By , 23 Sep 2011
Rate this:
Please Sign up or sign in to vote.
Screenshot - dotnetfx_installer1.jpg

Screenshot - dotnetfx_installer3.jpg

Introduction

This article contains a modular InnoSetup install script that downloads (if setup files don't exist already) and installs various dependencies like .NET Framework 1.1/2.0/3.5/4.0 and others on 32-bit or 64-bit Windows.

Background

Once upon a time, I needed an installer for my .NET applications. I knew that I could use the "genius" ClickOnce installer, but in my opinion it has a bad interface and is not very handy. Then I came across a script for InnoSetup that had everything I wanted, but unfortunately it was only for .NET 1.1. So, I spent a few hours (became more over time) in InnoSetup and modified it to my needs.

Details

The source code is written modular. The folder structure looks like this:

Screenshot - dotnetfx_content.jpg

  • setup.iss - contains the basic setup where you include the modules (products) you need. They need to be included at the top like #include "scripts\products\dotnetfx11.iss" and then you only have to call their main function inside the [Code] part like dotnetfx11();
  • bin - contains the final output of the installer
  • src - contains the application files of your program
  • scripts
    • products.iss - contains the shared code for the product scripts. You only have to change the [CustomMessages] part and [Files] part (inclusion of isxdl language files)
    • isxdl - contains the downloader DLL for the setup (if there is something to download) and its language files (e.g. german.ini). This is the place where you can put your language files for the isxdl downloader in.
    • products - contains the scripts for products which are required by the application (e.g. .NET Framework 2.0)
      • dotnetfx11.iss - .NET Framework 1.1
      • dotnetfx11lp.iss - .NET Framework 1.1 Language Pack
      • dotnetfx11sp1.iss - .NET Framework 1.1 + Service Pack 1
      • dotnetfx20.iss - .NET Framework 2.0
      • dotnetfx20lp.iss - .NET Framework 2.0 Language Pack
      • dotnetfx20sp1.iss - .NET Framework 2.0 + Service Pack 1
      • dotnetfx20sp1lp.iss - .NET Framework 2.0 Service Pack 1 Language Pack
      • dotnetfx20sp2.iss - .NET Framework 2.0 + Service Pack 2
      • dotnetfx20sp2lp.iss - .NET Framework 2.0 Service Pack 2 Language Pack
      • dotnetfx35.iss - .NET Framework 3.5
      • dotnetfx35lp.iss - .NET Framework 3.5 Language Pack
      • dotnetfx35sp1.iss - .NET Framework 3.5 + Service Pack 1
      • dotnetfx35sp1lp.iss - .NET Framework 3.5 Service Pack 1 Language Pack
      • dotnetfx40client.iss - .NET Framework 4.0 Client Profile
      • dotnetfx40full.iss - .NET Framework 4.0 Full
      • ie6.iss - Internet Explorer 6
      • iis.iss - Internet Information Services (just a check if it is installed)
      • jet4sp8.iss - Jet 4 + Service Pack 8
      • kb835732.iss - Security Update (KB835732) which is required by .NET Framework 2.0 Service Pack 1 on Windows 2000 Service Pack 4
      • mdac28.iss - Microsoft Data Access Components (MDAC) 2.8
      • msi20.iss - Windows Installer 2.0
      • msi31.iss - Windows Installer 3.1
      • msi45.iss - Windows Installer 4.5
      • sql2005express.iss - SQL Server 2005 Express + Service Pack 3
      • sql2008express.iss - SQL Server 2008 Express R2
      • sqlcompact35sp2.iss - SQL Server Compact 3.5 + Service Pack 2
      • vcredist2010.iss - Visual C++ 2010 Redistributable
      • wic.iss - Windows Imaging Component
      • winversion.iss - helper functions to determine the installed Windows version including service packs
      • fileversion.iss - helper functions to determine the version of a file
      • stringversion.iss - helper functions to correctly parse a version string
      • dotnetfxversion.iss - helper functions to determine the installed .NET Framework version including service packs

Mostly you may have to tweak the setup.iss because of different Windows version / service pack version check depending on the version of .NET Framework you need.

If a dependency (product) is not installed, the script checks if the product's setup exists inside the dependencies directory which is configurable in products.iss. By default it is: .\MyProgramDependencies. If they don't exist there, it tries to download them (except for Windows Service Packs). This means a support for offline installing via CD or DVD is also possible. In the recent versions, there was also support for 32-bit (x86) and 64-bit (x64) OS including Itanium (ia64) added.

Screenshot - dotnetfx_installer2.jpg

Screenshot - dotnetfx_installer4.jpg

The installation routine of the dependencies is automatic, and they run in quiet or semi quiet mode. Therefore no user interaction is needed, except for Internet Explorer 6. This setup script uses [CostumMessages] so that you can easily add multi-language support to your setup and are easily able to configure settings (like the dependencies directory) without looking at the [Code] part.

Applications used for the script are:

  • Inno Setup - setup engine (version 5.4.2)
  • ISTool - extends Inno Setup but I just needed the isxdl.dll downloader (version 5.3.0)

Known Problems

If dependencies are needed, the required free hard drive size is incorrect.

Points of Interest

Special thanks go to Ted Ehrich who created the .NET Framework 1.1 script. Well, I am sure that this script will serve me in the future very well and I hope you may like it too.

History

  • 14 Oct, 2007
    • Initial version
  • 19 Oct, 2007
    • Minor update to code
  • 27 Oct, 2007
    • Minor update to code
  • 25 Jan, 2008
    • Minor update to code
  • 15 Aug, 2008
    • Now uses dotnetchk.exe to determine which version of .NET Framework and its language pack is installed
    • Added .NET Framework language pack(s) to script
    • Added translation for download page
    • Separated script code into multiple files to make it easier to update the script for different versions of the .NET Framework
  • 1 Jan, 2009
    • Wrote source code modular (each dependency now has one file)
    • Added code for Windows security updates, .NET Framework 1.1, 2.0sp1, 3.5, 3.5sp1 and their language packs
    • No more dotnetchk.exe
  • 1 Sep, 2009
    • Code for dependencies installation routine was completely rewritten and is now executed before the actual installation of the application. Setup also checks if all dependencies are installed successfully and if not, displays an error page
    • Added support for 32-bit (x86) and 64-bit (x64) OS including Itanium (ia64)
    • Added code for .NET Framework 2.0 SP2 and its language pack
    • Fixed windows version check bug and language pack check bug
  • 23 Sep, 2011
    • Added support for .NET Framework 4.0, Windows Installer 4.5, Visual C++ 2010 Redistributable, SQL 2008 Express and SQL 3.5 Compact Edition (community)
    • Added helper functions to determine the installed .NET Framework version which removed redundant code
    • Added version strings parser to fix wrong detection for version numbers above 9
    • Added delayed and forced mid-install restart support
    • Added usage of #define in setup.iss (community)
    • Added unicode version of Inno Setup as default for better multilanguage support
    • Fixed restart on 3010 resultcode from installers
    • Fixed missing check in Windows 2000 Security Update (KB835732)
    • Added support for offline files on x64 and IA64 OS

License

This article, along with any associated source code and files, is licensed under The Code Project Open License (CPOL)

About the Author

stfx

Austria Austria
No Biography provided

Comments and Discussions

 
Questionsql compact fails install Pinmemberred2ltd5-Mar-12 9:55 
QuestionRe: sql compact fails install Pinmemberbastek7929-Mar-12 2:09 
AnswerRe: sql compact fails install Pinmemberstfx11-Apr-12 11:43 
GeneralRe: sql compact fails install PinmemberFreddyvdh8-May-12 1:37 
Hi, I have the same problem. The changes don't fix the problem. The downloaded file is a selfextracting file containing two msi-files.
GeneralRe: sql compact fails install Pinmemberse7enth8-May-12 4:06 
GeneralRe: sql compact fails install PinmemberFreddyvdh9-May-12 3:02 

General General    News News    Suggestion Suggestion    Question Question    Bug Bug    Answer Answer    Joke Joke    Rant Rant    Admin Admin   

Use Ctrl+Left/Right to switch messages, Ctrl+Up/Down to switch threads, Ctrl+Shift+Left/Right to switch pages.

| Advertise | Privacy | Mobile
Web04 | 2.8.140415.2 | Last Updated 23 Sep 2011
Article Copyright 2007 by stfx
Everything else Copyright © CodeProject, 1999-2014
Terms of Use
Layout: fixed | fluid